/*
// header - edit "Data/yourJavaHeader" to customize
// contents - edit "EventHandlers/Java file/onCreate" to customize
//
*/
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.math.*;

class ColorHSV
{
	public double h,s,v;
	public ColorHSV(int h){
		this.h = h;
		s = 1;
		v = 1;
	}
	public ColorHSV(double h){
		this.h = h;
		s = 1;
		v = 1;
	}
	public Color getRGB(){
		return ColorRBG(h,s,v);
	}
	public void setHue(double h){
		this.h = h;
	}
	public Color getDark(){
		return ColorRBG(h,1,0.5);
	}
	public Color getLight(){
		return ColorRBG(h,0.2,1);
	}
	public static Color getRGB(double hue){
		return ColorHSV.ColorRBG(hue,0.2,1);
	}
	public static Color ColorRBG(double h, double s, double v){
		double r, g, b;
		h = (h-3)/360;
		if ( s == 0 )                       //HSV values = From 0 to 1
		{
			r = v * 255;                     //RGB results = From 0 to 255
			g = v * 255;
			b = v * 255;
		}
		else
		{
			double var_h, var_i , var_1, var_2, var_3;
			double var_r, var_g, var_b;
			
			var_h = h * 6;
			var_i = Math.floor( var_h ) ;            //Or ... var_i = floor( var_h )
			var_1 = v * ( 1 - s );
			var_2 = v * ( 1 - s * ( var_h - var_i ) );
			var_3 = v * ( 1 - s * ( 1 - ( var_h - var_i ) ) );
			
			if      ( (int)Math.floor(var_i) == 0 ) 
			{ var_r = v     ; var_g = var_3 ; var_b = var_1; }
			else if ( (int)Math.floor(var_i) == 1 )
			{ var_r = var_2 ; var_g = v     ; var_b = var_1 ;}
			else if ( (int)Math.floor(var_i) == 2 ) 
			{ var_r = var_1 ; var_g = v     ; var_b = var_3; }
			else if ((int)Math.floor(var_i) == 3 ) 
			{ var_r = var_1 ; var_g = var_2 ; var_b = v  ;   }
			else if ( (int)Math.floor(var_i) == 4 ) 
			{ var_r = var_3 ; var_g = var_1 ; var_b = v ;    }
			else                   
			{ var_r = v     ; var_g = var_1 ; var_b = var_2; }
			
			r = var_r * 255;                  //RGB results = From 0 to 255
			g = var_g * 255;
			b = var_b * 255;
		}
		return new Color((int)r, (int)g, (int)b);
	}
	
		public static void main(String args[]){
			ColorHSV color = new ColorHSV(358); //exempel p hur ColorHSV kan anvndas
			System.out.println("color:\t" +color.getRGB().getRed()+"\t" +color.getRGB().getBlue()+"\t" +color.getRGB().getGreen());
			}
	
	
}

