/*******************************************************************************
Communication and User Interface   -   Java exercises
Martin Florin and Ivan Rankin autumn 2001   -   Campus Norrkping, Linkping University
********************************************************************************
Class UmpaLumpaCreationDialog is a modal dialog that lets the user input all the data
necessary to create an UmpaLumpa3.
***************************************************/

import java.awt.*; // to access components needed to build a gui 
import java.awt.event.*; // needed for event handling (buttons, menus)
import javax.swing.*; // needed in order to use Swing components

public class CreationDialog extends JDialog {
	
	// declarations - first everything we use to build the interface
	private Container contentpane;
	
	private JButton okButton;
	private JButton cancelButton;
	
	private JLabel NameLabel;
	private JLabel IdLabel;

	private JTextField NameTextfield;
	private JTextField IdTextfield;
	
	// all other variables
	private String namn;
	private String id;
	
	// constructor
	public CreationDialog (String title) {
		
		//Add the Title
		setTitle(title);
		
		// Place the JDialog and set the size. By using method getScreenSize
		// and width, we can calculate the location in order to center the JDialog.
		setSize(350, 180);
		setLocation(getToolkit().getScreenSize().width/2 - getSize().width/2, getToolkit().getScreenSize().height/3 - getSize().height/2);
		setResizable(false);
		// this makes the JDialog modal - the JDialog stays focused until the user clicks the right button
		setModal(true);
		
		// initiate all the components, set some colours and behaviour
		okButton = new JButton("OK");
		okButton.setMnemonic(KeyEvent.VK_N);
		okButton.setToolTipText("Klicka fr att skapa ny anvndare");
		
		cancelButton = new JButton("Avbryt");
		cancelButton.setMnemonic(KeyEvent.VK_C);
		cancelButton.setToolTipText("Klicka fr att avbryta.");
		
		NameLabel = new JLabel("Skriv namnet p den nya anvndaren:");
		NameLabel.setForeground(Color.black);
		NameLabel.setBackground(Color.white);
		
		IdLabel = new JLabel("Skriv id fr den nya anvndaren:");
		IdLabel.setForeground(Color.black);
		IdLabel.setBackground(Color.white);
				
		NameTextfield = new JTextField(30);
		NameTextfield.setForeground(Color.black);
		NameTextfield.setBackground(Color.white);
		
		IdTextfield = new JTextField(30);
		IdTextfield.setForeground(Color.black);
		IdTextfield.setBackground(Color.white);
		
		// choose LayoutManager
		contentpane = getContentPane();
		contentpane.setLayout(null);
		
		// add the components to the contentpane
		contentpane.add(okButton);
		contentpane.add(cancelButton);
		contentpane.add(NameLabel);
		contentpane.add(NameTextfield);
		contentpane.add(IdLabel);
		contentpane.add(IdTextfield);
		
		// set the position and size of the components in the contentpane
		NameLabel.setBounds(50, 10, 250, 20);
		NameTextfield.setBounds(50, 40, 250, 20);
		IdLabel.setBounds(50, 70, 250, 20);
		IdTextfield.setBounds(50, 100, 250, 20);
		okButton.setBounds(50, 130, 100, 20);
		cancelButton.setBounds(160, 130, 100, 20);
		
		// add listener to the JDialog
		addWindowListener(dialogListener);
		
		// add listeners to the components that can generate actions
		okButton.addActionListener(ActionListener);
		cancelButton.addActionListener(ActionListener);
		
		// set some initial states
		NameTextfield.setNextFocusableComponent(okButton);
		okButton.setNextFocusableComponent(NameTextfield);
	}
	
	public String getName() {
		// this is called in the main program to return the umpa entered by the user in the JDialog
		return namn;
	}
	
	public String getId() {
		// this is called in the main program to return the umpa entered by the user in the JDialog
		return id;
	}
	
	// create a windowlistener
	WindowListener dialogListener = new WindowAdapter() {
		// if the user closes the JDialog
		public void windowClosing(WindowEvent e) {
			namn = null; // empty the umpa
			id = null;
			NameTextfield.requestFocus(); // set focus on the textfield
			NameTextfield.setText(""); // empty the textfield
			// put the JDialog at the initial position
			setLocation(getToolkit().getScreenSize().width/2 - getSize().width/2, getToolkit().getScreenSize().height/3 - getSize().height/2);
		}
	};
	
	// create an actionlistener for buttons
	ActionListener ActionListener = new ActionListener() {
		
		public void actionPerformed(ActionEvent e) {
			
			// the user hits the ok button
			if (e.getSource() == okButton) {
				// create a temporary umpa that can be sent back to the main program
				namn = NameTextfield.getText().trim();
				id = IdTextfield.getText().trim();
				hide(); // hides the JDialog, lets the main program continue its execution of the code
				NameTextfield.requestFocus();
				NameTextfield.setText("");
				setLocation(getToolkit().getScreenSize().width/2 - getSize().width/2, getToolkit().getScreenSize().height/3 - getSize().height/2);
			}
			
			// the user hits the cancel button
			if (e.getSource() == cancelButton) {
				namn = null;
				id = null;
				hide();
				NameTextfield.requestFocus();
				NameTextfield.setText("");
				setLocation(getToolkit().getScreenSize().width/2 - getSize().width/2, getToolkit().getScreenSize().height/3 - getSize().height/2);
			}
		}
	};
}
