/*
	* Author: Jonas Hellsten
	* Created: den 26 november 2003 16:41:29
	* Modified: den 26 november 2003 16:41:29
	*/
import java.util.*;
import java.util.Random;
import java.lang.Character.*;
import java.lang.Math.*;

public class Schema
{
	public static final int DAYS = 5; //how many DAYS in a week
	public static final int TIME = 5; //how many TIMEslots in a day
	public Slot[][] slots = null; // [dag][timme]
	public int vecka;
	public String sal;
	
	public  Schema (int aVecka, String aSal){
		this.vecka = aVecka;
		this.sal = aSal;
		slots = new Slot[DAYS][TIME];
		
		for(int i = 0; i<DAYS; i++) //fyll matrisen med null
		{
			for(int j = 0; j<TIME; j++)
			{
				slots[i][j] = null;
			}
		}
	}
	
	public boolean add(int dag, int tid, User user, String label, String subject, String tooltiptext){
		
		if ( (dag >= DAYS || dag < 0) || (tid>=TIME || tid < 0)){
			return false; //kolla om dag o tid r giltiga
		}
		if (slots[dag][tid] != null){ //kolla om anvndaren har rtt att boka
			if (slots[dag][tid].user == user || user.admin){
				slots[dag][tid] = new Slot (user ,label, subject, tooltiptext);
				return true;
			}
			else 
				return false;
		}
		slots[dag][tid] = new Slot (user, label, subject, tooltiptext);
		return true;
	}
	
	public boolean remove( int dag, int tid, User user){
		
		if ( (dag >= DAYS || dag < 0) || (tid >= TIME || tid < 0)){
			return false;
		}
		if (slots[dag][tid] == null)
			return true;
		if (slots[dag][tid].user == user || user.admin){
			slots[dag][tid] = null;
			return true;
		}
		return false;
	}
	public Schema copy(){
		Schema tmp = new Schema(this.vecka, new String(this.sal));
		for(int i = 0; i<DAYS; i++) //fyll matrisen med null
		{
			for(int j = 0; j<TIME; j++)
			{
				if (this.slots[i][j] == null)
					tmp.slots[i][j] = null;
				else
					tmp.slots[i][j] = this.slots[i][j].copy();
			}
		}
		return tmp;
	}
	
	
}
