/*
 * Author: Jonas Hellsten
 * Created: den 2 december 2003 19:15:13
 * Modified: den 2 december 2003 19:15:13
 */


import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*; // needed for event handling (buttons, menus)

import java.sql.*;


public class UserHandler
{
	public static final int MAX_USERS = 100;
	protected JPanel panel = new JPanel();
	private static final int BUTTONWIDTH = 100, BUTTONHEIGHT = 20;
	private static final int ICON_X = 10, ICON_Y = 10;
	
	
	//objects for the collorslider and starting values
	private static final int SLIDERX = 60+100*2+10, SLIDERY = 500-4*BUTTONHEIGHT;
	private static final int COLOR_MIN = 0;
	private static final int COLOR_MAX = 360;
	private static final int COLOR_INIT = 15;    //initial frames per second
	private JSlider colorSlider;
	private JLabel userName;
	private JLabel colorField;
	private Color labelColor;
	private JButton confirm;
	private JButton undo;
	private ColorHSV labelColorHSV = new ColorHSV(3);
	//list objects
	public static final int LISTX = 30, LISTY = 150;
	private JList list;
	private DefaultListModel listModel;
	private JScrollPane listScroller;
	//adding and removing users
	//private JButton addUserButton = new JButton("Lgg till", new ImageIcon("icons/add_smal.png"));
	JButton addUserButton = new JButton("Lgg till", 
			new ImageIcon(Toolkit.getDefaultToolkit().getImage("icons/add_smal.png").getScaledInstance(ICON_X, ICON_Y, Image.SCALE_SMOOTH)));
	private JButton removeUserButton = new JButton("Ta bort", 
		new ImageIcon(Toolkit.getDefaultToolkit().getImage("icons/minus_smal.png").getScaledInstance(ICON_X, ICON_Y, Image.SCALE_SMOOTH)));
	private CreationDialog createUser = new CreationDialog("Lgg till Anvndare");
	
	//checkBoxes for chosing subjects
	public static final int CHECKX = SLIDERX, CHECKY = LISTY;
	private JCheckBox matte;
	private JCheckBox engelska;
	private JCheckBox fysik;
	private JCheckBox svenska;
	private JCheckBox kemi;
	private JCheckBox samm;
	private JCheckBox admin;
	
	//objects used by this class
	private SchemaBokning schemabok;
	public User users[];
	public User currentUser;
	private User markedUser;
	
	//Objects for the database connection 
	Connection con;
	Statement stmt;
	
	//initiates the list with the users, and add/remove buttons
	private  void makeList(){
		listModel = new DefaultListModel();
		if( connect() ){
			try{
				ResultSet rs = stmt.executeQuery("SELECT teachid FROM Teachers");
				while( rs.next() ){
					listModel.addElement( rs.getString(1) );
				}
			}
			catch (SQLException e) {
     			System.out.println("Fel i listskapning: "+e.getSQLState());
    		}
		} 
			
		list = new JList(  listModel );
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		list.setLayoutOrientation(JList.VERTICAL );
		list.setVisibleRowCount(-1);
		
		JPanel userBorder = new JPanel();
		userBorder.setBorder (BorderFactory.createTitledBorder("Anvndare"));
		userBorder.setBounds(LISTX-10 ,LISTY -30 ,BUTTONWIDTH*2+30, 350+50);
		userBorder.setOpaque(false);
		panel.add(userBorder);
		list.setToolTipText("Markera den anvndare du vill ndra");
		listScroller = new JScrollPane(list);
		listScroller.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS );
		listScroller.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER );
		listScroller.setBounds(LISTX ,LISTY ,BUTTONWIDTH,350);
		listScroller.setMaximumSize(new Dimension(100, 300));
		
		list.addListSelectionListener(listListener);
		
		panel.remove(listScroller);
		panel.add(listScroller);
		
		addUserButton.setToolTipText("Lggtill ny anvndare");
		
		addUserButton.setMnemonic(KeyEvent.VK_L);
		addUserButton.setHorizontalAlignment(SwingConstants.LEFT);
		addUserButton.setEnabled(true);
		addUserButton.setBounds(LISTX+BUTTONWIDTH,LISTY,BUTTONWIDTH,BUTTONHEIGHT);
		addUserButton.addActionListener(userListener);
		panel.add(addUserButton);
		
		removeUserButton.setToolTipText("Tabort markerad anvndare");
		removeUserButton.setMnemonic(KeyEvent.VK_T);
		removeUserButton.setHorizontalAlignment(SwingConstants.LEFT);
		removeUserButton.setEnabled(false);
		removeUserButton.setBounds(LISTX+BUTTONWIDTH,LISTY+BUTTONHEIGHT, BUTTONWIDTH, BUTTONHEIGHT);
		removeUserButton.addActionListener(userListener);
		panel.add(removeUserButton);
	}
	//inititates the checkBoxes for chosing subjects
	private void addKryssbox(){
		//creates a transparent panel with a border
		JPanel kryssBorder = new JPanel();
		kryssBorder.setBorder (BorderFactory.createTitledBorder("mnesval"));
		kryssBorder.setBounds(CHECKX-10 ,CHECKY -30 ,BUTTONWIDTH+70, BUTTONHEIGHT*6+50);
		kryssBorder.setOpaque(false);
		panel.add(kryssBorder);
		
		/*Creates checkboxes for the subject buttons  */
		matte = new JCheckBox("Matematik");
		matte.setMnemonic(KeyEvent.VK_M);
		matte.setBackground(schemabok.DEFAULTCOLOR);
		matte.setSelected(false);
		matte.setEnabled(false);
		matte.setBounds(CHECKX,CHECKY +0*BUTTONHEIGHT, BUTTONWIDTH + 50, BUTTONHEIGHT);
		matte.setToolTipText("Undervisa matematik");
		engelska = new JCheckBox("Engelska");
		engelska.setMnemonic(KeyEvent.VK_E);
		engelska.setBackground(schemabok.DEFAULTCOLOR);		
		engelska.setSelected(false);
		engelska.setEnabled(false);
		engelska.setBounds(CHECKX,CHECKY +1*BUTTONHEIGHT, BUTTONWIDTH + 50, BUTTONHEIGHT);
		engelska.setToolTipText("Undervisa engelska");
		fysik = new JCheckBox("Fysik");
		fysik.setMnemonic(KeyEvent.VK_F);
		fysik.setBackground(schemabok.DEFAULTCOLOR);		
		fysik.setSelected(false);
		fysik.setEnabled(false);
		fysik.setBounds(CHECKX,CHECKY +2*BUTTONHEIGHT, BUTTONWIDTH + 50, BUTTONHEIGHT);
		fysik.setToolTipText("Undervisa fysik");
		svenska = new JCheckBox("Svenska");
		svenska.setMnemonic(KeyEvent.VK_V);
		svenska.setBackground(schemabok.DEFAULTCOLOR);		
		svenska.setSelected(false);
		svenska.setEnabled(false);
		svenska.setBounds(CHECKX,CHECKY +3*BUTTONHEIGHT, BUTTONWIDTH + 50, BUTTONHEIGHT);
		svenska.setToolTipText("Undervisa svenska");
		kemi = new JCheckBox("Kemi");
		kemi.setMnemonic(KeyEvent.VK_K);
		kemi.setBackground(schemabok.DEFAULTCOLOR);		
		kemi.setSelected(false);
		kemi.setEnabled(false);
		kemi.setBounds(CHECKX,CHECKY +4*BUTTONHEIGHT, BUTTONWIDTH + 50, BUTTONHEIGHT);
		kemi.setToolTipText("Undervisa kemi");
		samm = new JCheckBox("KomA");
		samm.setMnemonic(KeyEvent.VK_H);
		samm.setBackground(schemabok.DEFAULTCOLOR);		
		samm.setSelected(false);
		samm.setEnabled(false);
		samm.setBounds(CHECKX,CHECKY +5*BUTTONHEIGHT, BUTTONWIDTH + 50, BUTTONHEIGHT);
		samm.setToolTipText("Undervisa Kommunikation och Anvndargrnssnitt");
		
		/*Creates border for the admin button*/
		JPanel adminBorder = new JPanel();
		adminBorder.setBorder (BorderFactory.createTitledBorder("Administratr"));
		adminBorder.setBounds(450-10 ,LISTY -30 ,BUTTONWIDTH+20, BUTTONHEIGHT+50);
		adminBorder.setOpaque(false);
		panel.add(adminBorder);
		admin = new JCheckBox("Admin");
		samm.setMnemonic(KeyEvent.VK_D);
		admin.setBackground(schemabok.DEFAULTCOLOR);		
		admin.setSelected(false);
		admin.setEnabled(false);
		admin.setBounds(450 , LISTY, BUTTONWIDTH+0,BUTTONHEIGHT);
		admin.setToolTipText("Vlj om anvndaren ska ha administrativa privilegier");
		
		//Register a listener for the check boxes.
		matte.addItemListener(kryssListener);
		engelska.addItemListener(kryssListener);
		fysik.addItemListener(kryssListener);
		svenska.addItemListener(kryssListener);
		kemi.addItemListener(kryssListener);
		samm.addItemListener(kryssListener);
		admin.addItemListener(kryssListener);
		panel.add ( matte );
		panel.add ( engelska );
		panel.add ( fysik );
		panel.add ( svenska );
		panel.add ( kemi );
		panel.add ( samm );
		panel.add ( admin );
	}
	//constructors
	public UserHandler(SchemaBokning schemaWindow){

		schemabok = schemaWindow;
		panel.setLayout(null);
		//skapa listan
		makeList();
		//initiera kryssrutorna fr mnen o admin
		addKryssbox();
		//initiera slidern fr att vlja frg
		JPanel sliderBorder = new JPanel();
		sliderBorder.setBorder (BorderFactory.createTitledBorder("Frgval"));
		sliderBorder.setBounds(SLIDERX-10 ,SLIDERY -30 ,300+20, 4*BUTTONHEIGHT+50);
		sliderBorder.setOpaque(false);
		panel.add(sliderBorder);
		
		colorSlider = new JSlider(JSlider.HORIZONTAL,
			COLOR_MIN, COLOR_MAX, COLOR_INIT);
		
		colorSlider.setMajorTickSpacing(60);
		colorSlider.setMinorTickSpacing(1);
		colorSlider.setPaintTicks(true);
		colorSlider.setPaintLabels(true);
		colorSlider.setEnabled(false);
		
		colorSlider.setBounds(SLIDERX,SLIDERY,300,2*BUTTONHEIGHT);
		colorSlider.addChangeListener(sliderListener);
		colorSlider.setBackground(schemabok.DEFAULTCOLOR);
		colorSlider.setToolTipText("vlj frg fr anvndare");
		
		
		
		labelColor = schemabok.DEFAULTCOLOR;
		colorField = new JLabel("");
		colorField.setBackground(labelColor);
		colorField.setOpaque(true);
		colorField.setBounds(SLIDERX,SLIDERY + 50 ,300,BUTTONHEIGHT);
		colorField.setToolTipText("vald frg");
		
		confirm = new JButton("Bekrfta", 
			new ImageIcon(Toolkit.getDefaultToolkit().getImage("icons/OK_smal.png").getScaledInstance(ICON_X, ICON_Y, Image.SCALE_SMOOTH)));
		confirm.setMnemonic(KeyEvent.VK_B);
		confirm.setEnabled(false);
		confirm.setBounds(SLIDERX, SLIDERY + BUTTONHEIGHT +50, 150,BUTTONHEIGHT);
		confirm.setToolTipText("Bekrfta frgndring");
		confirm.addActionListener(userListener);
		panel.add(confirm);
		
		undo = new JButton("ngra", 
			new ImageIcon(Toolkit.getDefaultToolkit().getImage("icons/cancel_smal.png").getScaledInstance(ICON_X, ICON_Y, Image.SCALE_SMOOTH)));
		undo.setMnemonic(KeyEvent.VK_N);
		undo.setEnabled(false);
		undo.setBounds(SLIDERX + 150 , SLIDERY + BUTTONHEIGHT +50, 150, BUTTONHEIGHT);
		undo.setToolTipText("Avbryt frgndring");
		undo.addActionListener(userListener);
		panel.add(undo);
		
		userName = new JLabel("<html><font size=6 >Ingen anvndare vald</font></html>");
		userName.setOpaque(false);
		userName.setBounds(LISTX,20,500,50);
		userName.setForeground(Color.black);
		userName.setToolTipText("Markerad Anvndare");
		
		panel.setBorder( BorderFactory.createTitledBorder("Anvndarhantering") );
		panel.add ( userName );
		panel.add ( colorSlider );
		panel.add ( colorField );
		panel.setBackground(schemabok.DEFAULTCOLOR);
		
	}
	public UserHandler( ){
	}
	
	
	private boolean connect(){
		try{
	   	Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	   
	   	String url = "jdbc:odbc:torvald";
		con = DriverManager.getConnection(url,
	                     "tnm017+018_102", "tnm017+018_102A");
	    stmt = con.createStatement();
	    return true;
	    }
	    catch (SQLException e) {
     		System.out.println("Error: SQLException\n Error in connecting:\t" +e.getSQLState());
    	}
    	catch (ClassNotFoundException e) {
     		System.out.println("Error: ClassNotFoundException\n Error in connecting:\t");
    	}
    	catch (Exception e) {
     		System.out.println("Error: Exception\n Error in connecting:\t");
    	}
    	return false;
	}
	private boolean disconnect(){
		try{
	  	stmt.close();
	    con.close();
	    return true;
	    }
	    catch (Exception e) {
	     System.out.println("failed to disconnect");
	    }
	    return false;
	}
	
	public boolean login(String id){
		currentUser = makeUser(id);
		if (currentUser != null){
			System.out.println("Inloggning lyckades");
			return true;
		}
		else{
			System.out.println("Inloggning misslyckades");
			return false;	
		}
	}
	
	public User makeUser(String id){
		connect();
		String loginName = id.trim();
		//System.out.println("loggar in");
		User returnUser = null;
		try{
			ResultSet rs = stmt.executeQuery("SELECT * FROM Teachers LEFT OUTER JOIN Admin ON Teachers.teachid = Admin.teachid WHERE Teachers.teachid = '"+loginName+"';");
			if(rs.next()){
				returnUser = new User(rs.getString(1), rs.getString(2), rs.getInt(3));
				
				if( rs.getString(4) != null)
					returnUser.admin = true;
				
				ResultSet subjects =  stmt.executeQuery("SELECT coursename FROM Have, Courses WHERE teachID = '"+loginName+"' AND Courses.courseid = have.courseid;");
				while( subjects.next() ){
					String sub = subjects.getString(1);
					if(sub.compareTo("matte") == 0)
						returnUser.matte = true;
					if(sub.compareTo("svenska") == 0)
						returnUser.svenska = true;
					if(sub.compareTo("fysik") == 0)
						returnUser.fysik = true;
					if(sub.compareTo("engelska") == 0)
						returnUser.engelska = true;
					if(sub.compareTo("kemi") == 0)
						returnUser.kemi = true;
					if(sub.compareTo("samm") == 0)
						returnUser.samm = true;
				}
	
			}
				
			else{
				System.out.println("ingen anvndare med det namnet");
				}
		}
		catch (SQLException e) {
     		System.out.println("FEL i markera anvndare: "+e.getSQLState());
    	}
    	disconnect();
    	return returnUser;
	}
	
	public void logout(){
		currentUser = null;
	}

	public String getName(){
		if (currentUser == null )
			return "no user logged in";
		if (currentUser.admin)
			return currentUser.name + " [admin]";
		return currentUser.name;
	}
	public String getId(){
		if (currentUser == null )
			return "no user logged in";
		else {
			//System.out.println("id:" + currentUser.id);
			return currentUser.id;
		}
	}
	
	public void dissableButtons(){
		removeUserButton.setEnabled(false);
		matte.setEnabled(false);
		engelska.setEnabled(false);
		fysik.setEnabled(false);
		svenska.setEnabled(false);
		kemi.setEnabled(false);
		samm.setEnabled(false);
		admin.setEnabled(false);
		colorSlider.setEnabled(false);
		admin.setEnabled(false);
		
	}

	ActionListener userListener = new ActionListener() {
		
		public void actionPerformed(ActionEvent e) 
		{
			
			if (e.getSource() == addUserButton) 
			{
				createUser.show();
				User tmp = new User(createUser.getId(), createUser.getName());
				if (tmp != null){
					tmp.setColor(3);
					if (tmp != null){
						if( tmp.name.length() > 30){
							JOptionPane.showMessageDialog(null, "Frlngt namn", "Ogiltig tillgg", JOptionPane.ERROR_MESSAGE, null);
							return ;
						}
						if( tmp.name.length() < 3){
							JOptionPane.showMessageDialog(null, "Frkort namn", "Ogiltig tillgg", JOptionPane.ERROR_MESSAGE, null);
							return ;
						}
						//add user to the database if name is not taken
						connect();
						try{
							if(stmt.executeQuery("SELECT * FROM Teachers WHERE teachID = '"+tmp.id+"';").next() ){
								JOptionPane.showMessageDialog(null, "Anvndarnamnet redan anvnt", "Ogiltig tillgg", JOptionPane.ERROR_MESSAGE, null);
								}
							else{
								stmt.executeUpdate("INSERT INTO Teachers (teachid, teachName , teachColor) VALUES ('"+tmp.id+"', '"+tmp.name+"',"+tmp.getHue()+");");
								markedUser = tmp;
								listModel.addElement(tmp.id);
								list.setSelectedIndex(listModel.getSize()-1) ;
								}
							}
						catch (SQLException error) {
     						System.out.println("FEL i add user: "+error.getSQLState());
    						}
    					disconnect();
					}
				}	
			}
			
			if (e.getSource() == confirm) 
			{
				connect();
				try{
					stmt.executeUpdate("UPDATE Teachers SET Teachcolor = "+labelColorHSV.h+" WHERE teachid = '"+markedUser.id+"';");
				}
				catch (SQLException error) {
     				System.out.println("FEL i add user: "+error.getSQLState());
    				}
    			disconnect();
				markedUser.userColor.setHue(labelColorHSV.h);
			}
			if (e.getSource() == undo) 
			{
				colorSlider.setValue((int)markedUser.userColor.h);
				labelColor = labelColorHSV.getLight();
				colorField.setBackground(labelColor);
			}
			if (e.getSource() == removeUserButton) 
			{
				int change = JOptionPane.showConfirmDialog(null, " Vill du radera anvndare","Bekrfta borttagning?",JOptionPane.WARNING_MESSAGE);
				if (change == 0){
					if (markedUser != null){
						
						//anslut till databasen
						connect();
						try{
							//testa om anvndaren finns, och i s fall, ta bort honom
							if(stmt.executeQuery("SELECT * FROM Teachers WHERE teachID = '"+markedUser.id+"';").next() ){
								stmt.executeUpdate("DELETE  FROM Teachers WHERE teachID = '"+markedUser.id+"';");
								
								//tar bort anvndaren frn listan och nollstller valda anvndaren.
								for (int i = 0; i<listModel.getSize(); i++){
									if (markedUser.id.compareTo(listModel.getElementAt(i)) == 0)
										listModel.remove(i);
								}
								markedUser = null;
								dissableButtons();
								labelColor = schemabok.DEFAULTCOLOR;
								colorField.setBackground(labelColor);
								userName.setText("Ingen anvndare vald");
								list.clearSelection();
								}
							}
						catch (SQLException error) {
     						System.out.println("FEL i remove user: "+error.getSQLState());
    						}
    					disconnect();	
					}
				}	
			}
		}
		
	};
	ChangeListener sliderListener = new ChangeListener(){
		
		public void stateChanged(ChangeEvent e) {
			JSlider source = (JSlider)e.getSource();
			if (source.getValueIsAdjusting()) {
				//kollar p frgvljaren och uppdaterar rutan under
				labelColor = ColorHSV.getRGB( source.getValue() );
				colorField.setBackground(labelColor);
			}
			else {
				labelColorHSV.setHue( source.getValue() );
			}
		}
	};
	//lysnar p mnesvalen
	ItemListener kryssListener = new ItemListener(){
		
		public void itemStateChanged(ItemEvent e) {
			Object source = e.getItemSelectable();
			
			if (markedUser != null){
				connect();
				
				/* identifies the selected course*/
				String courseid = "nothing";
				if (source == matte) {
					courseid = "tng001";
				} else if (source == engelska) {
					courseid = "tng002";
				} else if (source == fysik) {
					courseid = "tng003";
				} else if (source == svenska) {
					courseid = "tng004";
				} else if (source == kemi) {
					courseid = "tng005";
				} else if (source == samm) {
					courseid = "tng006";
				}	
				if (source == admin) {
					try{
						/* adds or deletes the subject from the ADMIN table */
						if(e.getStateChange() == 1){
							if(!stmt.executeQuery("SELECT * FROM Admin WHERE teachID = '"+markedUser.id+"';").next() )
								stmt.executeUpdate("INSERT INTO Admin (teachid) VALUES ('"+markedUser.id+"');");
								}
						else if(e.getStateChange() == 2){
							if(stmt.executeQuery("SELECT * FROM Admin WHERE teachID = '"+markedUser.id+"';").next() )
								stmt.executeUpdate("DELETE FROM Admin WHERE teachID = '"+markedUser.id+"';");
							}
						}
						catch (SQLException error) {
     						System.out.println("FEL i krysslysnare: "+error.getSQLState());
    					}

				}
				else{
					try{
						/* adds or deletes the subject from the HAVE table */
						if(e.getStateChange() == 1){
							if(!stmt.executeQuery("SELECT * FROM Have WHERE teachID = '"+markedUser.id+"' AND courseid = '"+courseid+"';").next() )
								stmt.executeUpdate("INSERT INTO Have (teachid, courseid) VALUES ('"+markedUser.id+"','"+courseid+"');");	
						}
						else if(e.getStateChange() == 2){
							if(stmt.executeQuery("SELECT * FROM Have WHERE teachID = '"+markedUser.id+"' AND courseid = '"+courseid+"';").next() )
								stmt.executeUpdate("DELETE FROM Have WHERE teachID = '"+markedUser.id+"' AND courseid = '"+courseid+"';");	
						}
					}
					catch (SQLException error) {
     					System.out.println("FEL i krysslysnare: "+error.getSQLState());
    				}
				}
				disconnect();
				currentUser = makeUser(currentUser.id);
			}
			
		}	
	};
	
	//lysnar p listan med anvndare
	ListSelectionListener listListener = new ListSelectionListener(){
		
		public void valueChanged(ListSelectionEvent e) {
			if (e.getValueIsAdjusting() == false) {
				int selected = list.getSelectedIndex();
				if ( selected != -1) {
					//No selection, disable fire button.
					removeUserButton.setEnabled(true);
					colorSlider.setEnabled(true);
					
					/* get the marked user and update the list */
					markedUser = makeUser( (String) listModel.getElementAt(selected) );
					if (markedUser != null){
						colorSlider.setValue((int)markedUser.userColor.h);
						
						userName.setText("<html><font size = 6>Vald anvndare:"+markedUser.name+"</font></html>");
						//den fungerar!
						labelColor = markedUser.userColor.getLight();
						colorField.setBackground(labelColor);
						
						//System.out.println(markedUser.name+ "\t" +markedUser.matte+" "+markedUser.fysik+" "+markedUser.engelska+" "+markedUser.svenska+" "+markedUser.samm+" "+markedUser.admin+" ");
						//Enable all checkboxes 
						matte.setEnabled (true);
						fysik.setEnabled (true);
						engelska.setEnabled (true);
						svenska.setEnabled (true);
						kemi.setEnabled (true);
						samm.setEnabled (true);
						admin.setEnabled (true);
						confirm.setEnabled(true);
						undo.setEnabled(true);
						
						//bugg workaround
						boolean tmp;
						tmp = markedUser.matte;
						matte.setSelected(markedUser.matte);
						markedUser.matte = tmp;
						tmp = markedUser.fysik;
						fysik.setSelected(markedUser.fysik);
						markedUser.fysik = tmp;
						tmp = markedUser.engelska;
						engelska.setSelected(markedUser.engelska);
						markedUser.engelska = tmp;
						tmp = markedUser.svenska;
						svenska.setSelected(markedUser.svenska);
						markedUser.svenska = tmp;
						tmp = markedUser.kemi;
						kemi.setSelected(markedUser.kemi);
						markedUser.kemi = tmp;
						tmp = markedUser.samm;
						samm.setSelected(markedUser.samm);
						markedUser.samm = tmp;
						tmp = markedUser.admin;
						admin.setSelected(markedUser.admin);
						markedUser.admin = tmp;						
					}
				}
			}
		}
		
	};
}



