// ===================================================================
// db:      spdb.mdb
// dsn:     spdb-sql70
// skapad:  2003-01-19 / janpe
// ndrad:  2003-01-19 / janpe
// ===================================================================

import java.sql.*;

class dbCon
{
	//variabler
	Connection con;
	Statement stmt;
	String currentUserID, currentUserName;
	boolean currentAdmin;
	int currentColor;
	
	
	//logga in
	public  void login(String loginName) 
	{ 
		loginName = loginName.trim();
		System.out.println("loggar in");
		if(con == null){
			System.out.println("anslutning finns ej");
			return;
		}
		if(stmt == null){
			System.out.println("anslutning finns ej");
			return;
		}
			
			
		try{
			//ResultSet rs = stmt.executeQuery("SELECT * FROM Teachers LEFT OUTER JOIN Admin ON Teachers.teachid = Admin.teachid WHERE Teachers.teachid = '"+loginName+"';");
			//ResultSet rs = stmt.executeQuery("SELECT * FROM Teachers WHERE teachid = 'jonhe';");
			ResultSet rs = stmt.executeQuery("SELECT * FROM Teachers LEFT OUTER JOIN Admin ON Teachers.teachid = Admin.teachid WHERE Teachers.teachid = '"+loginName+"';");
			if(rs.next()){
				
				currentUserID = rs.getString(1);
				currentUserName = rs.getString(2);
				currentColor = rs.getInt(3);
				if( rs.getString(4) != null)
					currentAdmin = true;
				else
					currentAdmin = false;
				System.out.println("ID: "+currentUserID +"\tName: " +currentUserName+ "\tAdmin: " +currentAdmin);
			}
				
			else{
				System.out.println("inte inloggad");
				}

		}
		
		catch (SQLException e) {
     		System.out.println("FEL i inloggning: "+e.getSQLState());
    	}	
	}
	
	public boolean addUser(String userID, String userName, int colorID, boolean admin){
		userID = userID.trim();
		userName = userName.trim();
		
		if(!currentAdmin || userID == currentUserID){
			return false;
		}
		
    	try {
    		ResultSet rs = stmt.executeQuery("SELECT * FROM Teachers WHERE teachid = '"+userID+"';");
    		if(!rs.next()){
    			System.out.println("Anvndare finns inte");
    			stmt.executeUpdate("INSERT INTO Teachers " + 
    							"VALUES ('"+userID+"', '"+userName+"', "+colorID+")");
    			if(admin)
    			stmt.executeUpdate("INSERT INTO Admin VALUES ('"+userID+"')");
    			System.out.println("Anvndare skapad");
    			}
    		else{
	    		System.out.println("Anvndare finns redan, ta ett annat namn");
	    		return false;
    			}
    		}
    		
    	catch (SQLException e) {
     		System.out.println("Error: SQLException\n Error in adduser:\t" +e.getSQLState());
     		return false;
    	}
    	catch (Exception e) {
     		System.out.println("Error: Exception\n Error in adduser:\t");
     		return false;
    	}

		return true;
		}
		
		
	public void getSchedule() {
		try {
			ResultSet schedule = stmt.executeQuery( "SELECT time, day, week, info, room, Schedule.courseid, Schedule.teachid, coursename, teachname, teachcolor FROM Schedule, Courses, Teachers WHERE Courses.courseid=Schedule.courseid AND Schedule.teachid = Teachers.teachid ORDER BY week, day, time;");
			int weekold=0; //spara tempvecka
			if(schedule.wasNull()) { System.out.println("Tomt");}
			else {
	    		while (schedule.next()) {
	        	int time = schedule.getInt("time");
	        	int day = schedule.getInt("day");
	        	int week = schedule.getInt("week");
	        	String info = schedule.getString("info");
	       		String room = schedule.getString("room");
		        String courseid = schedule.getString("courseid");
		        String teachid = schedule.getString("teachid");
		        String coursename = schedule.getString("coursename");
		        String teachname = schedule.getString("teachname");
		        int teachcolor = schedule.getInt("teachcolor");
		        
		        //Vecka, skriver ut veckonumret
		        if (weekold != week)
		        	{System.out.println("\nVecka: "+week+"\n");}
		        weekold = week; //stt nytt veckonummer
		        //Dag, skriver ut vilken dag det gller
		        if (day==1)
		        	System.out.println("Mn ");
		        if (day==2)
		        	System.out.println("Tis ");
		        if (day==3)
		        	System.out.println("Ons ");
		        if (day==4)
		        	System.out.println("Tor ");
		        if (day==5)
		        	System.out.println("Fre ");
		        //Tid, skriver ut tiden under dagen
		        if (time==1) 
		        	System.out.println("08-10 ");
		        if (time==2)
		        	System.out.println("10-12 ");
		        if (time==3) 
		        	System.out.println("13-15 ");
		        if (time==4)
		        	System.out.println("15-17 ");
		        //Sal, skriver ut salsnumret (troligtvis samma sal hela tiden)
		        System.out.println(room+" ");
		        System.out.println("Lrare: "+teachname+", "+teachid+"\nKursinfo: "+info);
		        System.out.println(courseid+": "+coursename);
		       }
			}
		}
    	catch (SQLException e) {
     		System.out.println("Error: SQLException\n Error in adduser:\t" +e.getSQLState());
     	//	return false;
    	}
    	catch (Exception e) {
     		System.out.println("Error: Exception\n Error in adduser:\t");
     	//	return false;
    	}
	}
	
		
	public boolean removeUser(String userID){
		userID = userID.trim();
		
		if(!currentAdmin || userID == currentUserID){
			System.out.println("Fr inte ta bort dig sjlv!");
			return false;
		}
		
		try { //Tar bort anvndaren frn Tabellen Teachers
    		ResultSet rs = stmt.executeQuery("SELECT * FROM Teachers WHERE teachid = '"+userID+"';");
    		if(rs.next()){
    			System.out.println("Anvndare tas bort");
    			stmt.executeUpdate("DELETE FROM Teachers WHERE teachid = '"+userID+"';");
    			System.out.println("Anvndare borttagen");
    			}
    			
    		else{
	    		System.out.println("Anvndare finns inte att ta bort");
	    		return false;
    			}
    			
    		//Tar bort anvndaren frn tabellen Admin,
    		ResultSet rsAdmin = stmt.executeQuery("SELECT * FROM Admin WHERE teachid = '"+userID+"';");
    		if(rsAdmin.next()){
    			System.out.println("Admin tas bort");
    			stmt.executeUpdate("DELETE FROM Admin WHERE teachid = '"+userID+"';");
    			System.out.println("Admin borttagen");
    			}
    			
    		else{
	    		System.out.println("Admin finns inte att ta bort");
    			}
    		}
    		
    	catch (SQLException e) {
     		System.out.println("Error: SQLException\n Error in removeUser:\t" +e.getSQLState());
     		return false;
    	}
    	catch (Exception e) {
     		System.out.println("Error: Exception\n Error in removeUser:\t");
     		return false;
    	}
    	return true;
		
	}
	//constructor
	public dbCon(){
		
		currentAdmin = false;
		connect();
	}
	//skapa anslutning
	public  void connect()
	{
		try{
		
	   	Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	   
	   	String url = "jdbc:odbc:torvald";
		con = DriverManager.getConnection(url,
	                     "tnm017+018_102", "tnm017+018_102A");
	    stmt = con.createStatement();
	    }
	    catch (SQLException e) {
     		System.out.println("Error: SQLException\n Error in connecting:\t" +e.getSQLState());
    	}
    	catch (ClassNotFoundException e) {
     		System.out.println("Error: ClassNotFoundException\n Error in connecting:\t");
    	}
    	catch (Exception e) {
     		System.out.println("Error: Exception\n Error in connecting:\t");
    	}
  }
  
  public void disconnect(){
  	try{
  	stmt.close();
    con.close();
    }
    catch (Exception e) {
     System.out.println("failed to disconnect");
    }
  }
  
  public static void main(String[] args) 
  {
  	
   		System.out.println("skapar databas");
   		dbCon user = new dbCon();
   		
   		System.out.println("databas skapad, ska logga in");
   		user.login("jonhe");
   		System.out.println("inloggad, hmtar schema");
   		user.getSchedule();
   		//user.addUser("bjogu","bjrn",50, false);
   		//user.removeUser("bjogu");
   		
   		user.disconnect();
   		


  }
  
  
   private void printTable(ResultSet rs) throws SQLException
  {
    ResultSetMetaData rsmd = rs.getMetaData();
    
    // print column names
    for (int i = 1; i <= rsmd.getColumnCount(); i++) {
      System.out.print(rsmd.getColumnName(i) + "\t");
    }
    System.out.println();

    // print rows
    while (rs.next()) {
      for (int i = 1; i <= rsmd.getColumnCount(); i++) {
        System.out.print(rs.getString(i) + "\t");
      }     
      System.out.println();
    }
  }
}
